//variable definitions for this test
var SXH_SERVER_CERT_IGNORE_ALL_SERVER_ERRORS = 13056;
// URLs used to start and stop a recording session
var startURL = "http://manualexploreserver:9999/start?port=3232";
var fileName = "MyRecording" + new Date().getTime(); //adding a timestamp to avoid conflicts
var stopURL = "http://manualexploreserver:9999/stop?port=3232&fileName=" + fileName;


var strAseUser = "domain\\user";
var strAsePW = "******"
//Create an instance of ServerXMLHTTP (msxml6 required)
xmlhttp = new ActiveXObject ("MSXML2.ServerXMLHTTP.6.0");
xmlhttp.setOption(2) = SXH_SERVER_CERT_IGNORE_ALL_SERVER_ERRORS;
xmlhttp.open("GET", startURL, false);
//send the request to start recording
xmlhttp.send();
WScript.Echo("The Response Status for Start Recording: " + xmlhttp.status);
response = xmlhttp.responseText;
WScript.Echo("");
WScript.Echo(response);
//only send requests if we were able to start recording
if (xmlhttp.status == "200")
{
	//Record some urls
	xmlhttp.setProxy("2", "manualexploreserver:3232","manualexploreserver"); 
	WScript.Echo("Visiting http://demo.testfire.net");
	xmlhttp.open("GET", "http://demo.testfire.net", false);
	xmlhttp.send();
	WScript.Echo("Visiting http://demo.testfire.net/default.aspx?content=personal_deposit.htm");
	xmlhttp.open("GET", "http://demo.testfire.net/default.aspx?content=personal_deposit.htm", false);
	xmlhttp.send();
	WScript.Echo("Visiting http://demo.testfire.net/default.aspx?content=inside.htm");
	xmlhttp.open("GET", "http://demo.testfire.net/default.aspx?content=inside.htm", false);
	xmlhttp.send();
	WScript.Echo("Visiting http://demo.testfire.net/default.aspx?content=privacy.htm");
	xmlhttp.open("GET", "http://demo.testfire.net/default.aspx?content=privacy.htm", false);
	xmlhttp.send();
	
	//send the request to stop recording and save the file
	xmlhttp.open("GET", stopURL, false);
	xmlhttp.send();
	WScript.Echo("The Response Status for Stop Recording: " + xmlhttp.status);
	response = xmlhttp.responseText;
	WScript.Echo("");
	WScript.Echo(response);
}
else
	{
		WScript.Echo("Could not start a recording sessions using " + startURL);
	}     

//
//Create a content scan job based on a template
//we need to know the folder item id of the template job in order for this to work
xmlhttp = new ActiveXObject ("MSXML2.ServerXMLHTTP.6.0");
xmlhttp.setOption(2) = SXH_SERVER_CERT_IGNORE_ALL_SERVER_ERRORS;
/*
Alternative for Jazz based login
var requestURL = "https://aseserver/ase/services/login";
postData = "userid=ADMIN&password=ADMIN";
xmlhttp.open("POST", requestURL, false);
xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
xmlhttp.send(postData);
if  (xmlhttp.status != "200")
{
	WScript.Echo("The Response Status for Login: " + xmlhttp.status);
	response = xmlhttp.responseText;
	WScript.Echo("");
	WScript.Echo(response);
}
else
	{
*/
		//create a new content job based on a template job whose job id is known
		var requestURL = "http://aseserver/ase/services/folderitems?templateid=9";
		//set the name and description for the job
		postData = "name="+fileName+"&description=This job is created based on a simple scan template job.";
WScript.Echo("Creating Content Job - "+fileName);
		xmlhttp.open("POST", requestURL, false, strAseUser, strAsePW);
		xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlhttp.send(postData);
		response = xmlhttp.responseText;
		//retrieve the Url for the newly created job
		strJob = parseUrl(response, "<content-scan-job href=")
		WScript.Echo("Job Url = " + strJob);
		//retrieve the Url for the newly created report pack
		strRP = parseUrl(response, "<report-pack href=")
		WScript.Echo("Report Pack Url = " + strRP);
		
		//read the content of the htd file that we recorded
		objFs = new ActiveXObject("Scripting.FileSystemObject");
		var strLength;
		var strTraffic;
		var binaryStream;
		if (objFs.FileExists("\\\\manualexploreserver\\Recordings\\"+fileName+".htd"))
		{
			f = objFs.GetFile("\\\\manualexploreserver\\Recordings\\"+fileName+".htd");
			sLength = f.Size.toString();
			binaryStream = new ActiveXObject("ADODB.Stream");
			binaryStream.Type = 1;
		  binaryStream.Open();
		  binaryStream.LoadFromFile("\\\\manualexploreserver\\Recordings\\"+fileName+".htd");
		  strTraffic = binaryStream.Read();
		  binaryStream.Close();
		}
		else
			WScript.Echo("Could not find the traffic data file");
	//Upload the htd traffic
			WScript.Echo("Uploading the traffic data");
	 trafficUrl = strJob + "/httptrafficdata";
		xmlhttp.open("POST", trafficUrl, false, strAseUser, strAsePW);
		xmlhttp.setRequestHeader("Content-type", "application/octet-stream");
		xmlhttp.setRequestHeader("Content-Length", strLength);
		xmlhttp.send(strTraffic);
		response = xmlhttp.responseText;
	  WScript.Echo(response);
//Run the job

/*}*/
//strJob = "http://aseserver/ase/services/folderitems/21"
		postData = "action=2";
		xmlhttp.open("POST", strJob, false, strAseUser, strAsePW);
		xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlhttp.send(postData);
		response = xmlhttp.responseText;
		WScript.Echo("Running the job...");
		strState = waitUntilDone(strJob);
		if (strState == "1")
			WScript.Echo("Job ran successfully");
		else
				WScript.Echo("Job suspended");
		WScript.Echo("Waiting for reports to complete...");
		strState = waitUntilDone(strRP);
		if (strState == "1")
			WScript.Echo("Report Pack ran successfully");
		else
				WScript.Echo("Report Pack suspended");

		xmlhttp.open("GET", strRP+"/reports", false, strAseUser, strAsePW);
		xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlhttp.send();
		response = xmlhttp.responseText;
		WScript.Echo("Retrieving Security Issues Report");			
		strReportUrl = getReportDataUrl(response, "<name>Security Issues");
		xmlhttp.open("GET", strReportUrl, false, strAseUser, strAsePW);
		xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		xmlhttp.send();
		response = xmlhttp.responseText;
WScript.Echo(response);
		
function parseUrl(strHeader, strTag)
{
            var sPos = strHeader.search(strTag);
            strHeader = strHeader.substr(sPos);
            sPos = strHeader.search(/\">/);
            strHeader = strHeader.substr(0,sPos);
            sPos = strHeader.search(/\"/);
            strHeader = strHeader.substr(sPos+1,strHeader.length -sPos -1);
            return strHeader;
}
function waitUntilDone(strJob)
{
		var strState="";
		do
		{
			WScript.Sleep (10 * 1000);
			xmlhttp.open("GET", strJob, false, strAseUser, strAsePW);
			xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
			xmlhttp.send();
			response = xmlhttp.responseText;
			strState = getState(response)
		}
		while(strState != "1" && strState != "9" )
		return strState;
} 
function getState(strHeader)
{
//parse the job state from the REST api response
            var sPos = strHeader.search(/<state>/);
            strHeader = strHeader.substr(sPos);
            sPos = strHeader.search(/<id>/);
            strHeader = strHeader.substr(sPos);
            sPos = strHeader.search(/<\/id>/);
            strHeader = strHeader.substr(4,sPos -4);
            return strHeader;
}
function getReportDataUrl(strHeader, strReport)
{
	//find the report data url from the report's REST api response
            var sPos = strHeader.search(strReport);
            strHeader = strHeader.substr(sPos);
            sPos = strHeader.search(/<data href=\"/);
            strHeader = strHeader.substr(sPos+12);
            sPos = strHeader.search(/\"/);
            strHeader = strHeader.substr(0,sPos);
            return strHeader;
}